// For fun, a quick demonstration I cooked up that combines
// direct manipulation from Module 03 with sliding friction.
// When the user releases the mouse, we allow the circle to
// continue in its current direction until it slides to a stop.

float friction = 1;

// Position
float x = 250;
float y = 250;
// Velocity
float vx = 0;
float vy = 0;

// Are we currently dragging?
boolean dragging;

void setup()
{
  size( 500, 500 );
  dragging = false;
}

void draw()
{
  background( 80 );

  if ( dragging ) {
    ellipse( mouseX, mouseY, 50, 50 );
  } else {
    // Run a small sliding friction simulation until the
    // circle stops moving.
    float m = mag( vx, vy );

    if ( m - friction <= 0 ) {
      // Not enough speed left to lose to friction.
      // So we grind to a halt here.
      vx = 0.0;
      vy = 0.0;
    } else {
      vx = vx - (vx/m)*friction;
      vy = vy - (vy/m)*friction;
    }

    x += vx;
    y += vy;

    ellipse( x, y, 50, 50 );
  }
}

void mousePressed()
{
  if ( dist( mouseX, mouseY, x, y ) < 25 ) {
    dragging = true;
  }
}

void mouseReleased()
{  
  if ( dragging ) {
    dragging = false;
    vx = mouseX - pmouseX;
    vy = mouseY - pmouseY;
    x = mouseX;
    y = mouseY;
  }
}